// V1.1 11/25/2017 Wenderelais jetzt OK, Dezimalausdruck IR Empfang repariert
// In <boarddefs.h> zu finden in der Stepperbibliothek Timer 1 definieren!
// Nur notwendig, wenn auch IR verwendet wird, sonst beissen sich Timer 1 und Timer 2 
#include <boarddefs.h>
#include <IRremote.h>
#include <IRremoteInt.h> //IR Bibliotheken einbinden
#include <IRremote.h>  
#include <ir_Lego_PF_BitStreamEncoder.h>
#include <AccelStepper.h>  // Stepper Bibliothek einbinden
#define HALFSTEP 8         // 8 Schritte pro Sequenz d.h. Halbschrittbetrieb 
                           // 28BYJ-48 funktioniert damit am Besten
// Motor pin am Arduino definieren
#define motorPin1  4     // IN1 on the ULN2003 driver 1
#define motorPin2  5     // IN2 on the ULN2003 driver 1
#define motorPin3  6     // IN3 on the ULN2003 driver 1
#define motorPin4  7     // IN4 on the ULN2003 driver 1

const int irReceiverPin = 2;  //IR-Empfaenger an pin2 anschliessen
IRrecv irrecv(irReceiverPin); //IR- Empfaeenger definieren
decode_results results;       // und Struktur fuer empfangene Daten aufsetzen (die letzten beiden Zeilen 
                              // muss man nicht verstehen ;-)

int buttonState = 0;         // Variable fuer den Endschalter
boolean gewendet = false;    // Variable fuer Vor/Rueckwaerts wird beim Wenden gebraucht

// Steppertreiber initialisieren mit Pin Sequenz IN1-IN3-IN2-IN4
// damit AccelStepper mit 28BYJ-48 richtig funktioniert

AccelStepper stepper1(HALFSTEP, motorPin1, motorPin3, motorPin2, motorPin4);

// Arduino Programme haben alle die Struktur 
// void setup() die einmal zum Start durchlaufen wird
// void loop() , das dann endlos wiederholt wird

void setup() {
  pinMode(12, INPUT_PULLUP);  // Pin 12 als Eingang fuer Endschalter mit internem Widerstand definieren
  digitalWrite (12,HIGH);     // Sollte eigentlich nicht notwendig sein, aber schadet auch nicht
  pinMode (13, OUTPUT);       // Pin 13 als Relaisausgang fuer Polaritaetswechsel der Buehne
  digitalWrite (13,LOW);      // Anfangszustand "Aus"
  
  irrecv.enableIRIn();       // IR-Empfaenger initialisieren 
  Serial.begin(115200);      // Serielle Schnittstelle zum Laptop initialisieren,
                             // mit Tools->Serial Monitor kann man Meldungen an den Steuerrechner senden
  Serial.println("Hello");   // und gleich mal probieren
                             // Uebrigens Monitor erst aktivieren, wenn der "Upload" des Programms erfolgt ist.
                             // Wenn man den Beginn des Programms verfolgen will, einfach die Reset-Taste
                             // am Arduino Board druecken. Ohne angeschlossenen Rechner gehen die Meldungen
                             // einfach "ins Leere"

  stepper1.setMaxSpeed(100.0);    // Max Geschwindigkeit, Beschleunigung und gesetzte Geschwindigkeit einstellen 
  stepper1.setAcceleration(200.0);// Zum Suchen des Endschalters langsam fahren
  stepper1.setSpeed(50);
  stepper1.setCurrentPosition(0); // Position definiert auf "0" setzen
  stepper1.moveTo(20000);         // Einen weiten Weg vorgeben, damit die Drehscheibe den Endschalter erreicht

  // Setup sieht eigentlich keine Schleifen vor, deshalb "kuenstlich" mit while konstruiert
  buttonState = digitalRead(12);  // Endschalter einlesen, damit in der while-Schleife ein definierter Zustand entstejht
  while (buttonState == HIGH){    // Diese Schleife durchlaufen, solange der Endschalter nicht erreicht ist.
    buttonState = digitalRead(12);  // Endschalter bei jedem Durchlauf testen
    stepper1.run ();                // Besonderheit des Arduino, die Funktion muss haeufig aufgerufen werden (wie oft ?) 
  }
  // Endschalter wurde erreicht, while Schleife wird verlassen 
  stepper1.stop();                  // Stepper anhalten
  delay (1000);                     // Warten, bis er steht
  Serial.println ("Endschalter erreicht");
  stepper1.setMaxSpeed(1000.0);     // Nun Motor schneller machen fuer Normalbetrieb
  stepper1.setAcceleration(100.0);
  stepper1.setSpeed(200);
  stepper1.setCurrentPosition(0);   // Dies ist nun die endgueltige "Nullposition", von der aus alle Bewegungen
                                    // gezaehlt werden

}//--(end setup )---

void loop() {

  if (irrecv.decode(&results)) //Falls der IR-Empfaenger Daten bekommen hat
  {  
// Die folgenden Zeilen zeigen den empfangenen IR-Code an. Sie koennen dazu verwendet werden
// eine unbekannte IR-Fernbedienung zu analysieren
    Serial.print("irCode: ");    // IR-Daten ausdrucken         
    Serial.print(results.value, HEX); // in HEX sonst wird's zu lang 

    Serial.print(" Value: ");    //
    Serial.print((unsigned int)((long)results.value & (long)0x0000FFFF)); //nur die untersten 4 HEX Zahlen 

    Serial.print(",  bits: ");  //Zahl der Bits im IR-Telegramm         
    Serial.println(results.bits); //

// Der folgende Code behandelt die empfangenen Daten. Die Konstanten in "case" wurden zuvor aus den oben
// gewonnenen Daten extrahiert. Die "moveTo" Daten sind im Augenblick mehr oder weniger willkuerlich,
// sie muessen an die tatsaechlichen Werte angepasst werden.

    switch(results.value)
    {
      case 0xFF6897:
       Serial.println("0 gedrueckt");
       stepper1.moveTo(0);                 // Hier den Wert fuer Abgang "0" eintragen
       digitalWrite (13,LOW);              //  Umpolrelais fuer Bruecke aus
       gewendet = false;                   //  und es wird nicht gewendet
      break;
  
      case 0xFF30CF:
        Serial.println("1 gedrueckt");    // Und hier fuer Abgang 1 etc.
        stepper1.moveTo(500);
        digitalWrite (13,LOW);            //  Umpolrelais fuer Bruecke aus
        gewendet = false;
      break;
  
     case 0xFF18E7:
        Serial.println("2 gedrueckt");
        stepper1.moveTo(1000);
        digitalWrite (13,LOW);  //  Umpolrelais fuer Bruecke aus
        gewendet = false;
     break;
  
     case 0xFF7A85:
        Serial.println("3 gedrueckt");
        stepper1.moveTo(1500);
        digitalWrite (13,LOW);  //  Umpolrelais fuer Bruecke aus
        gewendet = false;
     break;

     case 0xFF10EF:
        Serial.println("4 gedrueckt");
        stepper1.moveTo(2000);
        digitalWrite (13,LOW);  //  Umpolrelais fuer Bruecke aus
        gewendet = false;
     break;

     case 0xFF38C7:
       Serial.println("5 gedrueckt");
       stepper1.moveTo(2500);
       digitalWrite (13,LOW);  //  Umpolrelais fuer Bruecke aus
       gewendet = false;
     break;

     case 0xFF5AA5:
       Serial.println("6 gedrueckt");
       stepper1.moveTo(3000);
       digitalWrite (13,LOW);  //  Umpolrelais fuer Bruecke aus
       gewendet = false;
     break;

     case 0xFF22DD:
       Serial.println("Wenden gedrueckt");  // Um Aufwickeln zu vermeiden, entweder in oder gegen Uhrzeiger
       gewendet = !gewendet;    // Falls Wenden mehrfach gedrueckt wird, wechselt "gewendet" jedesmal den Zustand
       if (stepper1.currentPosition() < 2033){    // Der Wert 2033 entspricht der Schrittzahl fuer eine halbe Umdrehung
        stepper1.moveTo(stepper1.currentPosition()+2033);
        Serial.println("clockwise");
        }
        else {
         stepper1.moveTo(stepper1.currentPosition()-2033);
         Serial.println("anti-clockwise");
        }
       if (gewendet == true){     // Bruecke muss umgepolt werden, wenn gewendet wird
         digitalWrite (13,HIGH);}  //  Umpolrelais fuer Bruecke ein
       else {
         digitalWrite (13,LOW);} //  Umpolrelais fuer Bruecke aus
       Serial.println(gewendet);
     break;
// Falls keine der obigen Bedingungen erfuellt wird z.B. falsche Taste gedrueckt oder andere IR-Fernbedienung
// default - tu nix
      default:
      break;
    }
    irrecv.resume();    // Suche nach dem naechste IR-Telegramm 
  }
  stepper1.run ();    // wie gesagt, muss haeufig aufgerufen werden...
}
